;/ Decompiled by Champollion V1.0.1
Source   : CrowTimeSwitch.psc
Modified : 2021-05-02 18:41:50
Compiled : 2021-05-02 19:15:50
User     : Andre
Computer : BIFROST
/;
scriptName CrowTimeSwitch extends ObjectReference
{Controls a set of lights with a master enable parent marker with this script attached to turn on and off at the times of the day specified by the properties LightsOffTime and LightsOnTime}

;-- Properties --------------------------------------
Float property LightsOnTime = 18.0000 auto
{The time at which lights should be turned on}
Float property LightsOffTime = 7.00000 auto
{The time at which lights should be turned off}

;-- Variables ---------------------------------------

;-- Functions ---------------------------------------

Float function GetCurrentHourOfDay() global
{Returns the current time of day in hours since midnight}

	Float Time = utility.GetCurrentGameTime()
	Time -= math.Floor(Time) as Float
	Time *= 24 as Float
	return Time
endFunction

function RegisterForSingleUpdateGameTimeAt(Float GameTime)
{Registers for a single UpdateGameTime event at the next occurrence of the specified GameTime (in hours since midnight)}

	Float CurrentTime = CrowTimeSwitch.GetCurrentHourOfDay()
	if GameTime < CurrentTime
		GameTime += 24 as Float
	endIf
	self.RegisterForSingleUpdateGameTime(GameTime - CurrentTime)
endFunction

; Skipped compiler generated GetState

; Skipped compiler generated GotoState

function OnInit()

	if CrowTimeSwitch.GetCurrentHourOfDay() > LightsOffTime
		self.GotoState("LightsOff")
	else
		self.GotoState("LightsOn")
	endIf
endFunction

;-- State -------------------------------------------
state LightsOn

	function onBeginState()

		self.Enable(false)
		self.RegisterForSingleUpdateGameTimeAt(LightsOffTime)
	endFunction

	function OnUpdateGameTime()

		self.GotoState("LightsOff")
	endFunction
endState

;-- State -------------------------------------------
state LightsOff

	function onBeginState()

		self.Disable(false)
		self.RegisterForSingleUpdateGameTimeAt(LightsOnTime)
	endFunction

	function OnUpdateGameTime()

		self.GotoState("LightsOn")
	endFunction
endState
